---
title: Vibration API
slug: Web/API/Vibration_API
tags:
  - API
  - Beginner
  - Mobile
  - Vibration
---
<div>{{DefaultAPISidebar("Vibration API")}}</div>

<p class="summary">Most modern mobile devices include vibration hardware, which lets software code provide physical feedback to the user by causing the device to shake. The <strong>Vibration API</strong> offers Web apps the ability to access this hardware, if it exists, and does nothing if the device doesn't support it.</p>

<h2 id="Describing_vibrations">Describing vibrations</h2>

<p>Vibration is described as a pattern of on-off pulses, which may be of varying lengths. The pattern may consist of either a single integer, describing the number of milliseconds to vibrate, or an array of integers describing a pattern of vibrations and pauses. Vibration is controlled with a single method: {{DOMxRef("Navigator.vibrate()")}}.</p>

<h3 id="A_single_vibration">A single vibration</h3>

<p>You may pulse the vibration hardware one time by specifying either a single value or an array consisting of only one value:</p>

<pre class="brush:js notranslate">window.navigator.vibrate(200);
window.navigator.vibrate([200]);
</pre>

<p>Both of these examples vibrate the device for 200 ms.</p>

<h3 id="Vibration_patterns">Vibration patterns</h3>

<p>An array of values describes alternating periods in which the device is vibrating and not vibrating. Each value in the array is converted to an integer, then interpreted alternately as the number of milliseconds the device should vibrate and the number of milliseconds it should not be vibrating. For example:</p>

<pre class="brush: js notranslate">window.navigator.vibrate([200, 100, 200]);
</pre>

<p>This vibrates the device for 200 ms, then pauses for 100 ms before vibrating the device again for another 200 ms.</p>

<p>You may specify as many vibration/pause pairs as you like, and you may provide either an even or odd number of entries; it's worth noting that you don't have to provide a pause as your last entry since the vibration automatically stops at the end of each vibration period.</p>

<h3 id="Canceling_existing_vibrations">Canceling existing vibrations</h3>

<p>Calling {{DOMxRef("Navigator.vibrate()")}} with a value of <code>0</code>, an empty array, or an array containing all zeros will cancel any currently ongoing vibration pattern.</p>

<h3 id="Continued_vibrations">Continued vibrations</h3>

<p>Some basic <code>setInterval</code> and <code>clearInterval</code> action will allow you to create persistent vibration:</p>

<pre class="brush: js notranslate">var vibrateInterval;

// Starts vibration at passed in level
function startVibrate(duration) {
    navigator.vibrate(duration);
}

// Stops vibration
function stopVibrate() {
    // Clear interval and stop persistent vibrating
    if(vibrateInterval) clearInterval(vibrateInterval);
    navigator.vibrate(0);
}

// Start persistent vibration at given duration and interval
// Assumes a number value is given
function startPersistentVibrate(duration, interval) {
    vibrateInterval = setInterval(function() {
        startVibrate(duration);
    }, interval);
}</pre>

<p>Of course, the snippet above doesn't take into account the array method of vibration; persistent array-based vibration will require calculating the sum of the array items and creating an interval based on that number (with an additional delay, probably).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Vibration API")}}</td>
   <td>{{Spec2("Vibration API")}}</td>
   <td>Linked to spec is the latest editor's draft; W3C version is a REC.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Navigator.vibrate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Navigator.vibrate()")}}</li>
</ul>
